// This source is subject to the Microsoft Public License.
// See http://www.microsoft.com/resources/sharedsource/licensingbasics/sharedsourcelicenses.mspx.
// All other rights reserved.

using System;
using System.Text;
using System.Xml;

using QuoteAdvantage.CrmSdk;

namespace QuoteAdvantage
{
	/// <summary>
	/// Generic base class to provide utility functions to CRM classes
	/// </summary>
	public class CrmClass
	{
     
		public CrmClass()
		{
			
		}     
      
      public decimal GetDecimalValue(CrmMoney objField)
      {
         decimal nDecimal = 0;

         if (objField != null)
         {
            nDecimal = objField.Value;
         }

         return nDecimal;
      }

      public CrmMoney GetCrmMoneyValue(decimal nValue)
      {
         CrmMoney objResult = new CrmMoney();
         objResult.Value = nValue;
         return objResult;
      }

	} // end class
}
