// This source is subject to the Microsoft Public License.
// See http://www.microsoft.com/resources/sharedsource/licensingbasics/sharedsourcelicenses.mspx.
// All other rights reserved.

using System;
using System.Configuration;
using System.Xml;

namespace QuoteAdvantage
{
	/// <summary>
	/// Summary description for ConfiguratorSettings.
	/// </summary>
	public class ConfiguratorSettings
	{
      public string  Domain = "";
      public string  ServerName = "";
      public string  WebService = "";
      public string  UserID = "";
      public string  Password = "";

		public ConfiguratorSettings()
		{
		}

      public void LoadSettings(string strFileName)
      {
          Domain = ConfigurationManager.AppSettings["MSCRM_Domain"];
          ServerName = ConfigurationManager.AppSettings["MSCRM_Server"];
          WebService = ConfigurationManager.AppSettings["MSCRM_WebService"];
          UserID = ConfigurationManager.AppSettings["MSCRM_UserID"];
          Password = ConfigurationManager.AppSettings["MSCRM_Password"];
      }

	} // end class
}
